# Copyright (C) 2009 Raul Mircea Gigea <raul.gigea@gmail.com>

#
# Deluge is free software.
#
# You may redistribute it and/or modify it under the terms of the
# GNU General Public License, as published by the Free Software
# Foundation; either version 3 of the License, or (at your option)
# any later version.
#
# deluge is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with deluge.    If not, write to:
#     The Free Software Foundation, Inc.,
#     51 Franklin Street, Fifth Floor
#     Boston, MA  02110-1301, USA.
#
#    In addition, as a special exception, the copyright holders give
#    permission to link the code of portions of this program with the OpenSSL
#    library.
#    You must obey the GNU General Public License in all respects for all of
#    the code used other than OpenSSL. If you modify file(s) with this
#    exception, you may extend this exception to your version of the file(s),
#    but you are not obligated to do so. If you do not wish to do so, delete
#    this exception statement from your version. If you delete this exception
#    statement from all source files in the program, then also delete it here.
#
import threading
import urllib
import os
import datetime
import gobject
import time
import shutil
import sys
import smtplib
import fcntl


from deluge.log import LOG as log
from deluge.plugins.corepluginbase import CorePluginBase
import deluge.component as component
import deluge.configmanager

from deluge.plugins.coreclient import client

from smtplib import SMTP
from time import sleep, strftime
from datetime import datetime
import sys

# jabber stuff

import jabberbot
from jabberbot import JabberThread

#done jabber stuff

DEFAULT_PREFS = {
    "im_account": "",
    "im_pass": "",
    "mail_account": "",
    "mail_pass": "",
    "mail_smtp": "smtp.gmail.com",
    "im_notifyperson1": "",
    "im_notifyperson2": "",
    "mail_notifyperson1": "",
    "mail_notifyperson2": "",
}

def mail_headers(subject, from_, to, return_path):
    """
    Generate a formatted mail header string
    """
    
    header = 'Return-Path: ' + return_path 
    header = header + '\r\nFrom: ' + from_
    header = header + '\r\nReply-To: ' + return_path
    header = header + '\r\nTo: ' + to
    header = header + '\r\nSubject: '+subject

    now=datetime.now()

    day = now.strftime('%a')
    date = now.strftime('%d %b %Y %X')
    
    header = header + '\r\nDate : ' + day + ', ' + date + ' -0000\r\n'
    
    return (header)


class Core(CorePluginBase):
    def enable(self):
        log.debug('RemoteNotify: Plugin enabled.')

        self.core = component.get("Core")

        self.config = deluge.configmanager.ConfigManager("remotenotify.conf", DEFAULT_PREFS)

        component.get("AlertManager").register_handler("torrent_finished_alert", self.on_alert_torrent_finished)
        print('RemoteNotify: Starting Jabber Thread.')
        JabberThread.connect(self.config['im_account'], self.config['im_pass'])

    def disable(self):
        print('RemoteNotify: Jabber Reactor stopped')
        JabberThread.disconnect()
        print('RemoteNotify: Jabber Thread&Reactor stopped')
        #component.get("Core").export_reset_ip_filter()
        component.get("AlertManager").deregister_handler(self.on_alert_torrent_finished)
        self.config.save()
        log.debug('RemoteNotify: Plugin disabled')

    def update(self):
        pass

    def on_alert_torrent_finished(self, alert):

        try:
          torrent_id = str(alert.handle.info_hash())
          data = client.get_torrent_status(torrent_id, ["name","total_size", "ratio"])

          f = open('/tmp/remotenotify.log', 'w+')
          f.write("Your logic here :%s : %s" % (torrent_id, data))
          f.write("Sending mail to '%s'"%self.config['mail_notifyperson1'])
          f.close()

          # ---------- SEND EMAILS ---------------
          mail_sender = self.config['mail_account']
          note = "Greetz from the Deluge Remote Notifier"
          subject = "Download Completed:%s"%data['name']

          msg = mail_headers( subject, mail_sender, self.config['mail_notifyperson1'], mail_sender ) + '\r\n\r\n'+ note

          server = smtplib.SMTP(self.config['mail_smtp'])
          server.ehlo(mail_sender)
          server.starttls()
          server.ehlo(mail_sender)
          server.login(mail_sender, self.config['mail_pass'])

          server.sendmail(mail_sender,self.config['mail_notifyperson1'],msg)

          if ( len(self.config['mail_notifyperson2'] ) > 3 ):
            msg = mail_headers( subject, mail_sender, self.config['mail_notifyperson2'], mail_sender ) + '\r\n\r\n'+ note
            server.sendmail(mail_sender,self.config['mail_notifyperson2'],msg)

          server.quit()

          # -------------- SEND IM's -----------------
          JabberThread.sendMessage(self.config['im_notifyperson1'], subject)
          if ( len(self.config['im_notifyperson2']) > 3 ):
            JabberThread.sendMessage(self.config['im_notifyperson2'], subject)

        except Exception, e:
          log.debug("error in alert %s" % e)

    ## Exported RPC methods ###
    def export_get_config(self):
        """Returns the config dictionary"""
        return self.config.config

    def export_set_config(self, config):
        """Sets the config based on values in 'config'"""
        for key in config.keys():
            self.config[key] = config[key]

    ####


